﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace PaintNew
{
    

    public partial class PaintForm : Form
    {
        PaintClass paint;

        public PaintForm()
        {
            InitializeComponent();
            paint = new PaintClass(paintPictureBox);
            paint.ChangeForeColor += paint_ChangeForeColor;
        }

        void paint_ChangeForeColor(object sender, EventChangeColor e)
        {
            colorSelectPictureBox.BackColor = e.NewColor;
            colorLabel.BackColor = e.NewColor;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            paint.ForeColor = Color.Blue;
        }

        private void paintPictureBox_MouseClick(object sender, MouseEventArgs e)
        {
            paint.MouseClick(e);
        }

        private void paintPictureBox_MouseMove(object sender, MouseEventArgs e)
        {
            paint.MouseMove(e);
            toolStripStatusLabel1.Text = string.Format("Location X : {0} , Y : {1}", e.Location.X, e.Location.Y);
        }

        private void penPictureBox_Click(object sender, EventArgs e)
        {
            paint.ActionPaint = ActionPaintEnum.Pen;
        }

        private void linePictureBox_Click(object sender, EventArgs e)
        {
            paint.ActionPaint = ActionPaintEnum.Line;
        }

        private void criclePictureBox_Click(object sender, EventArgs e)
        {
            paint.ActionPaint = ActionPaintEnum.Circle;
        }

        private void newToolStripMenuItem_Click(object sender, EventArgs e)
        {
            paint.NewPaint();
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = FormClose();
        }

        private bool FormClose()
        {
            DialogResult result = MessageBox.Show("Do you want save picture ?", "Save Picture", MessageBoxButtons.YesNoCancel, MessageBoxIcon.Information, MessageBoxDefaultButton.Button1);

            if (result == System.Windows.Forms.DialogResult.Cancel)
            {
                return true;
            }
            else
            {
                if(result== System.Windows.Forms.DialogResult.Yes)
                    saveToolStripMenuItem_Click(this,new EventArgs());
                return false;
            }
        }

        private void openToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            DialogResult result= openFileDialog1.ShowDialog();
            if (result== System.Windows.Forms.DialogResult.OK )
            {
                paint.OpenFile( openFileDialog1.FileName);
                paintPictureBox.Refresh();
            }
        }

        private void saveToolStripMenuItem_Click(object sender, EventArgs e)
        {
            DialogResult result = saveFileDialog1.ShowDialog();
            if (result == System.Windows.Forms.DialogResult.OK)
            {
                paintPictureBox.Image.Save(saveFileDialog1.FileName);
            }
        }

        private void ColorPictureBox_Click(object sender, EventArgs e)
        {
            paint.ForeColor = ((PictureBox)sender).BackColor;
        }

        private void colorPictureBox_MouseMove(object sender, MouseEventArgs e)
        {
            toolStripStatusLabel1.Text = ((PictureBox)sender).BackColor.ToString();
        }

        private void penSizeTextBox_TextChanged(object sender, EventArgs e)
        {
            paint.PenSize = int.Parse(penSizeTextBox.Text);
        }

        private void colorPictureBox_MouseMove_1(object sender, MouseEventArgs e)
        {
            toolStripStatusLabel1.Text = "Select Color";
        }

        private void rectanglePictureBoxUI_Click(object sender, EventArgs e)
        {
            paint.ActionPaint = ActionPaintEnum.Rectangle;
            paint.FillObject = ((uiPictureBox)sender).CheckBoxValue;
        }

        private void criclePictureBoxUI_Click(object sender, EventArgs e)
        {
            paint.ActionPaint = ActionPaintEnum.Circle;
            paint.FillObject = ((uiPictureBox)sender).CheckBoxValue;
        }

        private void criclePictureBoxUI_ChangeCheckBox(object sender, EventChangeBox e)
        {
            paint.FillObject = e.CheckStatus;
        }

        private void penSizeTextBox_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (!char.IsNumber(e.KeyChar))
            {
                e.Handled = true;
            }
            else
                ((TextBox)sender).SelectAll();
        }

        private void PictureBoxUI_ChangeCheckBox(object sender, EventChangeBox e)
        {
            paint.FillObject = e.CheckStatus;
        }

        private void penPictureBoxUI_Click(object sender, EventArgs e)
        {
            paint.ActionPaint = ActionPaintEnum.Pen;
        }

        private void linePictureBoxUI_Click(object sender, EventArgs e)
        {
            paint.ActionPaint = ActionPaintEnum.Line;
        }

        private void erasePictureBoxUI_Click(object sender, EventArgs e)
        {
            paint.ActionPaint = ActionPaintEnum.Erase;
        }

        private void textPictureBoxUI_Click(object sender, EventArgs e)
        {
            paint.ActionPaint = ActionPaintEnum.Text;          
        }

        private void PictureBoxUI_MouseMove(object sender, MouseEventArgs e)
        {
            toolStripStatusLabel1.Text = ((uiPictureBox)sender).Name.Replace("PictureBoxUI", "").ToLower();
        }

        private void colorPictureBoxUI_Click(object sender, EventArgs e)
        {
            if (colorDialog1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                paint.ForeColor = colorDialog1.Color;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            paint.FillObject = false;
            paint.ActionPaint = ActionPaintEnum.Crop;

        }

        private void Rotate90Button_Click(object sender, EventArgs e)
        {
            paint.Rotate(90);
        }

        private void Rotate90MButton_Click(object sender, EventArgs e)
        {
            paint.Rotate(-90);
        }

        private void button1_Click_1(object sender, EventArgs e)
        {
            paint.ImageGrayScale();
        }



    }
}
