﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PaintNew
{
    public class PictureBox:System.Windows.Forms.PictureBox
    {
        //sajjad soltani
        //email : s.soltani1989@gmail.com
        //0355503633

        #region Fields...

        private System.Windows.Forms.BorderStyle _currentBordeStyle;
        private System.Drawing.Color _currentBackColor;
        private bool _activeMouseTracing;

        #endregion

        #region Properties...

        public System.Drawing.Color ColorTracing { get; set; }
       
        public bool ActiveMouseTracing
        {
            get { return _activeMouseTracing; }
            set {
                if (value)
                    BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
                _activeMouseTracing = value; }
        }

        #endregion

        #region Events...

        protected override void OnMouseEnter(EventArgs e)
        {
            base.OnMouseEnter(e);
            if (ActiveMouseTracing)
            {
                _currentBackColor = this.BackColor;
                this.BackColor = ColorTracing;
                this.Refresh();
            }
        }

        protected override void OnMouseLeave(EventArgs e)
        {
            base.OnMouseLeave(e);

            if (ActiveMouseTracing)
            {
                this.BackColor = _currentBackColor;
            }
        }

        protected override void OnMouseUp(System.Windows.Forms.MouseEventArgs e)
        {
            base.OnMouseUp(e);

            if (ActiveMouseTracing && e.Button == System.Windows.Forms.MouseButtons.Left)
            {             
                this.BorderStyle = _currentBordeStyle ;    
            }
        }

        protected override void OnMouseDown(System.Windows.Forms.MouseEventArgs e)
        {
            base.OnMouseDown(e);
            if (ActiveMouseTracing && e.Button == System.Windows.Forms.MouseButtons.Left )
            {
                _currentBordeStyle = this.BorderStyle;
                this.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
            }
        }

        #endregion
    }
}
